# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: settlement.proto
# plugin: python-betterproto
from dataclasses import dataclass
from datetime import datetime
from typing import List, Optional

import betterproto
import grpclib


@dataclass(eq=False, repr=False)
class Settlement(betterproto.Message):
    name: str = betterproto.string_field(1)
    id: int = betterproto.int64_field(2)
    player_id: int = betterproto.int64_field(3)
    pos: "Position" = betterproto.message_field(4)
    depot: "Depot" = betterproto.message_field(5)
    buildings: List["Building"] = betterproto.message_field(6)
    build_queue: List["BuildQueueItem"] = betterproto.message_field(7)
    build_queue_size: int = betterproto.int64_field(8)
    last_update: datetime = betterproto.message_field(9)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class BuildQueueItem(betterproto.Message):
    building_id: int = betterproto.int64_field(1)
    build_start: datetime = betterproto.message_field(2)
    build_end: datetime = betterproto.message_field(3)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Position(betterproto.Message):
    x: int = betterproto.int64_field(1)
    y: int = betterproto.int64_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Depot(betterproto.Message):
    store: List["ResourceStorage"] = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ResourceStorage(betterproto.Message):
    capacity: int = betterproto.int64_field(1)
    current_stored: int = betterproto.int64_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class SettlementList(betterproto.Message):
    settlements: List["Settlement"] = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Building(betterproto.Message):
    id: int = betterproto.int64_field(1)
    build_def: str = betterproto.string_field(3)
    in_construction: bool = betterproto.bool_field(4)
    hibernated: bool = betterproto.bool_field(5)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class BuildBuildingCall(betterproto.Message):
    settlement_id: "_common__.SettlementId" = betterproto.message_field(1)
    build_def: str = betterproto.string_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class UpgradeBuildingCall(betterproto.Message):
    settlement_id: "_common__.SettlementId" = betterproto.message_field(1)
    building_id: "_common__.BuildingId" = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


class SettlementServicesStub(betterproto.ServiceStub):
    async def add_settlement(
        self,
        *,
        name: str = "",
        id: int = 0,
        player_id: int = 0,
        pos: "Position" = None,
        depot: "Depot" = None,
        buildings: Optional[List["Building"]] = None,
        build_queue: Optional[List["BuildQueueItem"]] = None,
        build_queue_size: int = 0,
        last_update: datetime = None,
    ) -> "Settlement":
        buildings = buildings or []
        build_queue = build_queue or []

        request = Settlement()
        request.name = name
        request.id = id
        request.player_id = player_id
        if pos is not None:
            request.pos = pos
        if depot is not None:
            request.depot = depot
        if buildings is not None:
            request.buildings = buildings
        if build_queue is not None:
            request.build_queue = build_queue
        request.build_queue_size = build_queue_size
        if last_update is not None:
            request.last_update = last_update

        return await self._unary_unary(
            "/settlement.SettlementServices/AddSettlement", request, Settlement
        )

    async def add_test_settlement(
        self,
        *,
        name: str = "",
        id: int = 0,
        player_id: int = 0,
        pos: "Position" = None,
        depot: "Depot" = None,
        buildings: Optional[List["Building"]] = None,
        build_queue: Optional[List["BuildQueueItem"]] = None,
        build_queue_size: int = 0,
        last_update: datetime = None,
    ) -> "Settlement":
        buildings = buildings or []
        build_queue = build_queue or []

        request = Settlement()
        request.name = name
        request.id = id
        request.player_id = player_id
        if pos is not None:
            request.pos = pos
        if depot is not None:
            request.depot = depot
        if buildings is not None:
            request.buildings = buildings
        if build_queue is not None:
            request.build_queue = build_queue
        request.build_queue_size = build_queue_size
        if last_update is not None:
            request.last_update = last_update

        return await self._unary_unary(
            "/settlement.SettlementServices/AddTestSettlement", request, Settlement
        )

    async def get_settlement_by_id(self, *, id: int = 0) -> "Settlement":

        request = _common__.SettlementId()
        request.id = id

        return await self._unary_unary(
            "/settlement.SettlementServices/GetSettlementByID", request, Settlement
        )

    async def get_settlements_by_user_id(self, *, id: int = 0) -> "SettlementList":

        request = _common__.UserId()
        request.id = id

        return await self._unary_unary(
            "/settlement.SettlementServices/GetSettlementsByUserID",
            request,
            SettlementList,
        )

    async def delete_settlement(self, *, id: int = 0) -> "_common__.ResponseStatus":

        request = _common__.SettlementId()
        request.id = id

        return await self._unary_unary(
            "/settlement.SettlementServices/DeleteSettlement",
            request,
            _common__.ResponseStatus,
        )

    async def build_building(
        self, *, settlement_id: "_common__.SettlementId" = None, build_def: str = ""
    ) -> "_common__.ResponseStatus":

        request = BuildBuildingCall()
        if settlement_id is not None:
            request.settlement_id = settlement_id
        request.build_def = build_def

        return await self._unary_unary(
            "/settlement.SettlementServices/BuildBuilding",
            request,
            _common__.ResponseStatus,
        )

    async def upgrade_building(
        self,
        *,
        settlement_id: "_common__.SettlementId" = None,
        building_id: "_common__.BuildingId" = None,
    ) -> "_common__.ResponseStatus":

        request = UpgradeBuildingCall()
        if settlement_id is not None:
            request.settlement_id = settlement_id
        if building_id is not None:
            request.building_id = building_id

        return await self._unary_unary(
            "/settlement.SettlementServices/UpgradeBuilding",
            request,
            _common__.ResponseStatus,
        )


from .. import common as _common__
